unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Db, DBTables, ExtCtrls, ComCtrls, Grids, DBGrids,
  ToolWin,  ImgList, Buttons,shellapi,
  jpeg, ADODB, SHDocVw, OleCtrls, activex, Menus,optdata;

type
  TfrmMain = class(TForm)
    sb1: TStatusBar;
    ImageList1: TImageList;
    ImageList2: TImageList;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    mnuExit: TMenuItem;
    N4: TMenuItem;
    mnuToolbar: TMenuItem;
    mnuTree: TMenuItem;
    mnuList: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    CoolBar1: TCoolBar;
    Panel4: TPanel;
    Label1: TLabel;
    cbbID: TComboBox;
    ToolBar1: TToolBar;
    btnSetDB: TToolButton;
    btnSave: TToolButton;
    btnPrint: TToolButton;
    ToolButton7: TToolButton;
    btnPrior: TToolButton;
    btnNext: TToolButton;
    btnSearch: TToolButton;
    ToolButton2: TToolButton;
    btnFullScreen: TToolButton;
    btnAbout: TToolButton;
    btnUpdate: TToolButton;
    palTree: TPanel;
    Panel6: TPanel;
    TV1: TTreeView;
    Splitter2: TSplitter;
    Panel5: TPanel;
    Splitter1: TSplitter;
    PCContent: TPageControl;
    TSContent: TTabSheet;
    Panel3: TPanel;
    lblTitle: TLabel;
    TSInfo: TTabSheet;
    LVInfo: TListView;
    IE: TWebBrowser;
    mnuContent: TMenuItem;
    N5: TMenuItem;
    mnuUpdate: TMenuItem;
    mnuRefresh: TMenuItem;
    sgMain: TStringGrid;
    mnuOption: TMenuItem;
    N3: TMenuItem;
    mnuCacluAllRoomRecords: TMenuItem;
    N7: TMenuItem;
    pmnuDBlist: TPopupMenu;
    btnOption: TToolButton;
    ToolButton1: TToolButton;
    procedure ShowRecord(ID:integer);
    procedure LVInfoAdd(itemname,value:string);
    procedure FormCreate(Sender: TObject);
    procedure TV1Change(Sender: TObject; Node: TTreeNode);
    procedure btnSearchClick(Sender: TObject);
    procedure lbauthorClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnSetDBClick(Sender: TObject);
    procedure Init;
    procedure btnPriorClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure cbbIDKeyPress(Sender: TObject; var Key: Char);
    procedure btnPrintClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure mnuToolbarClick(Sender: TObject);
    procedure mnuTreeClick(Sender: TObject);
    procedure mnuListClick(Sender: TObject);
    procedure mnuContentClick(Sender: TObject);
    procedure btnFullScreenClick(Sender: TObject);
    procedure mnuUpdateClick(Sender: TObject);
    procedure mnuRefreshClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure sgMainSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure mnuCacluAllRoomRecordsClick(Sender: TObject);
    procedure mnuOptionClick(Sender: TObject);
  private
   { Private declarations }
    sltTreeViewKey:TStringlist;         //˱бTreeNodeRoomsID֮ĶӦϵ
  public
    { Public declarations }
    strCurTitle:string;

    procedure ShowHtml(Browser:TWebBrowser;content:string);
    procedure UpdateData;
    procedure InitpmnuDBlist;
    procedure OnpmnuDBClick(Sender:TObject);

  end;

var
  frmMain: TfrmMain;
  DsList:TDataSourceList;

implementation

uses ComObj,mshtml, Search, dm, htmlGen, update, option;

{$R *.DFM}


procedure TfrmMain.FormCreate(Sender: TObject);
var
    strConn:string;
    strlst:TStringList;
begin
       DsList := TDataSourceList.Create;
       DsList.LoadfromFile;
       InitpmnuDBlist;

       DM1.sgQList := sgMain;
       sgMain.OnDrawCell := DM1.OnDrawSGCell;

       sltTreeViewKey := TStringList.Create;

       if DsList.Count <> 0 then DM1.InitDB(DsList.Items[0].connstr)
               else  DM1.InitDB('');
       
       Init;

       btnAboutClick(self);

end;

procedure TfrmMain.TV1Change(Sender: TObject; Node: TTreeNode);
var
   ssql:string;
   oldcur:tcursor;
   Time:TDatetime;
   RoomID:integer;
begin
     if tv1.Selected =nil then exit;
     if TV1.Selected.Level = 1 then
     begin
        DM1.SelectNoRoom;
        exit;
     end;  

     if Node = TV1.TopItem then
        roomid := -1
     else
        roomid := strtoint(sltTreeViewKey.Values[inttostr(Node.AbsoluteIndex)]);
     tv1.Refresh;
     sb1.Panels[1].Text:='';
     oldcur:=Screen.Cursor;
     screen.cursor :=crHourGlass;
     Time := now;
     sb1.Panels[0].Text := 'ڲѯݡ';

     DM1.GetRoomRecord(RoomID);

     sb1.Panels[1].Text:= '¼' + inttostr(DM1.QuesCount) ;

     sb1.Refresh;

     sb1.Panels[3].Text:='Һʱ' + formatdatetime('hh:nn:ss:zz',now-time);
     sb1.Panels[2].Text:='' + TV1.Selected.Text;
     sb1.Panels[0].Text:='';
     screen.cursor :=oldcur;
end;

procedure TfrmMain.btnSearchClick(Sender: TObject);
var
   ssql,ssqlRe,TargetStr:string;
   oldcur:tcursor;
   Time:Tdatetime;
begin
     ssqlRe := '';
     with TfrmSearch.Create(self) do
     begin
          ShowModal;
          if Return = true then
          begin
               ssqlRe := SearchStr;
               TargetStr := Target;
          end;
          free;
     end;

     if ssqlRe = '' then  exit;

//     ȥעͽʾѯsqlַ
//     ShowMessage(ssqlRe);

     time:=now;
     sb1.Panels[0].Text:='ڲѯݡ';
     sb1.Panels[1].Text:='';
     sb1.Panels[2].Text:= TargetStr;
     sb1.Panels[3].Text:='';
     sb1.Refresh;

     try
     oldcur:=Screen.Cursor;
     screen.cursor :=crHourGlass;

     ssql := ssqlRe ;

     DM1.Search(ssql);

     finally
     sb1.Panels[1].Text:=''+ inttostr(DM1.QuesCount) + '¼';
     sb1.Refresh;
     screen.Cursor:=oldcur;
     sb1.Panels[0].Text:='';
     sb1.Panels[3].Text:='Һʱ' + formatdatetime('hh:nn:ss:zz',now-time);
     end;
end;

procedure TfrmMain.lbauthorClick(Sender: TObject);
begin
       apiexec('mailto:qinghou@china.com',SW_SHOWDEFAULT);
end;

procedure TfrmMain.Image1Click(Sender: TObject);
begin
     apiexec('http://onekey.yeah.net',SW_SHOWDEFAULT);
end;

procedure TfrmMain.ShowRecord(ID:Integer);
var
   i:integer;
   QuesInfo:TQuesInfo;
begin
     try
       DM1.GetQuesContent(ID,QuesInfo);

       sb1.Panels[0].Text:='ڸͼ';

       ShowHtml(IE,QuesInfo.Content);

       with QuesInfo do
       begin
           lblTitle.Caption:= '' + from + '' + subject;

           LVInfo.Items.Clear;
           LVInfoAdd('',subject);
           LVInfoAdd('',ID);
           LVInfoAdd('',from);
           LVInfoAdd('ʱ',RegdateTime);
           LVInfoAdd('ظʱ',datetime);
           LVInfoAdd('',Points);
           LVInfoAdd('״̬',Status);
           LVInfoAdd('',RoomName);

           LVInfoAdd('Ķ',GetTimes);
           LVInfoAdd('ظ',ReplyTimes);

       end;

       PCContent.ActivePageIndex := 0;
       frmMain.FocusControl(IE);
     finally
       sb1.Panels[0].Text:='';
     end;
end;

procedure TfrmMain.btnUpdateClick(Sender: TObject);
begin
        UpdateData;                
end;

procedure TfrmMain.btnSetDBClick(Sender: TObject);
var
        sltConn:TStringlist;
begin
        if DM1.SetConnnection then
        begin
//                DM1.InitDB('');
                Init;
        end;
end;

procedure TfrmMain.Init;
var
   TN1,TN2,TN3:TTreeNode;
   i,j:integer;
   Rooms:TStringlist;
begin
//       try
//                DM1.InitDB;
{       except
                ShowMessage('ʼݿʱ ');
                TV1.Items.Clear;
                exit;
       end;}

       TV1.Items.Clear;
       tn1:=tv1.Items.Add(nil,'ȫ');
       tn1.ImageIndex:=1;
       Rooms := TStringList.Create;

       sltTreeViewKey.Clear;

       with dm1 do
       begin
           for i := 0 to SltGroups.count - 1 do
           begin
             tn2:=tv1.Items.AddChild(tn1,trim(SltGroups[i]));
             tn2.ImageIndex:=1;

             GetRoomsByGroup(Rooms, TN2.Text);
             for j := 0 to Rooms.Count - 1 do
             begin
                 TN3 := TV1.Items.AddChild(TN2,Rooms.Names[j]);
                 TN3.ImageIndex := 1;
                 //TreeNodeRoomID֮ĶӦϵ
                 sltTreeViewKey.Add(inttostr(TN3.AbsoluteIndex) + '=' + Rooms.Values[Rooms.Names[j]]);
             end;
           end;
       end;

       Rooms.free;

       tv1.TopItem.Expand(false);
       if TV1.TopItem.Count <> 0 then
       begin
           TV1.TopItem.getFirstChild.Expand(false);
           TV1.Selected := TV1.TopItem.getFirstChild;
       end;

end;

procedure TfrmMain.btnPriorClick(Sender: TObject);
begin
{        with dbgMain.DataSource.DataSet do
        begin
                if Active then
                begin
                        Prior;
                        ShowRecord(Fieldbyname('ID').AsInteger);
                end;
        end;}

end;

procedure TfrmMain.btnNextClick(Sender: TObject);
begin
{        with dbgMain.DataSource.DataSet do
        begin
                if Active then
                begin
                        Next;
                        ShowRecord(Fieldbyname('ID').AsInteger);
                end;
        end;         }

end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
       lblTitle.Caption := 'Rich Explorer';
       LVInfo.Items.Clear;
       IE.OleObject.navigate(ExtractFilePath(Application.ExeName) + 'readme.htm');

end;

procedure TfrmMain.cbbIDKeyPress(Sender: TObject; var Key: Char);
begin
     if (Key <> #13) or (cbbID.Text = '') then exit;
        cbbID.Items.Add(cbbID.Text);
        if cbbID.Items.Count > 20 then cbbID.Items.Delete(0);
     try
        ShowRecord(strtoint(cbbID.Text));
        Key := #0;
     except
        messagebox(Handle,'ȷIDţ' ,'',mb_ok or MB_ICONWARNING);
     end;


end;

procedure TfrmMain.LVInfoAdd(itemname, value: string);
var
        ListItem:TListItem;
begin
     with LVInfo do
     begin
        ListItem := Items.Add;
        ListItem.ImageIndex := 2;
        ListItem.Caption := itemname;
        ListItem.SubItems.Add(value);
     end;

end;

procedure TfrmMain.btnPrintClick(Sender: TObject);
begin
        try
//        IE.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DODEFAULT, EmptyParam,EmptyParam);
        IE.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, EmptyParam,EmptyParam);
        except
        end;

end;


procedure TfrmMain.btnSaveClick(Sender: TObject);
begin
        try
        IE.ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DODEFAULT, EmptyParam, EmptyParam);
        Except
        end;

end;

procedure TfrmMain.ShowHtml(Browser:TWebBrowser;content: string);
var
    vv: Variant;
    HTMLDocument: IHTMLDocument2;
begin
        vv := VarArrayCreate([0,0],varVariant);
        vv[0] := content;
        HTMLDocument := browser.Document as IHTMLDocument2;
        HTMLDocument.write(PSafeArray(TVarData(vv).VArray));
        HTMLDocument.charset := 'gb2312';
        HTMLDocument.close;

end;

procedure TfrmMain.mnuToolbarClick(Sender: TObject);
begin
        mnuToolbar.Checked := not mnuToolbar.Checked;
        CoolBar1.Visible := mnuToolbar.Checked;
end;

procedure TfrmMain.mnuTreeClick(Sender: TObject);
begin
        mnuTree.Checked := not mnuTree.Checked;
        palTree.Visible := mnuTree.Checked;
end;

procedure TfrmMain.mnuListClick(Sender: TObject);
begin
        mnuList.Checked := not mnuList.Checked;
        sgMain.Visible := mnuList.Checked;
end;

procedure TfrmMain.mnuContentClick(Sender: TObject);
begin
        mnuContent.Checked := not mnuContent.Checked;
        PCContent.Visible := mnuContent.Checked;
end;

procedure TfrmMain.btnFullScreenClick(Sender: TObject);
begin
        mnuTreeClick(self);
        mnuListClick(self);
end;

procedure TfrmMain.mnuUpdateClick(Sender: TObject);
begin
        UpdateData;
end;

procedure TfrmMain.mnuRefreshClick(Sender: TObject);
begin
        DM1.InitDB('');
        Init;
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
        Close;
end;

procedure TfrmMain.UpdateData;
begin
        if frmUpdata <> nil then frmUpdata.show
        else
        begin
                frmUpdata := TfrmUpdata.Create(self);
                frmUpdata.Show;
        end;

end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
        sltTreeViewKey.free;
        DsList.SaveToFile;
        DsList.free;
end;

procedure TfrmMain.sgMainSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
        ID:string;
begin
        if ACol = 1 then
        begin
            ID := sgMain.Cells[0,aRow];
            if ID <> '' then ShowRecord(strtoint(ID));
        end;
end;

procedure TfrmMain.mnuCacluAllRoomRecordsClick(Sender: TObject);
var
   oldcur:tcursor;
begin
        try
              oldcur := Screen.Cursor;
              Screen.Cursor := crHourGlass;
              sb1.Panels[0].Text:='ڼ㡭';
              sb1.Refresh;
              DM1.CalcuAllRoomsRecords;
        finally
              Screen.Cursor := oldcur;
              sb1.Panels[0].Text:='ɡ';
        end;

end;

procedure TfrmMain.mnuOptionClick(Sender: TObject);
begin
        with TfrmOption.Create(self) do
        begin
                ShowModal;
                free;               
        end;
        InitpmnuDBlist;
end;

procedure TfrmMain.InitpmnuDBlist;
var
        i:integer;
        MenuItem:TMenuItem;
begin
        with pmnuDBlist do
        begin
                Items.Clear;
                for i := 0 to DsList.Count - 1 do
                begin
                        MenuItem := TMenuItem.Create(Self);
                        MenuItem.Caption := DsList.Items[i].Name;
                        MenuItem.OnClick := OnpmnuDBClick;
                        Items.Add(MenuItem);                      
                end;

        end;

end;


procedure TfrmMain.OnpmnuDBClick(Sender: TObject);
var
        i:integer;
        InitStr:string;
begin
        i := TMenuItem(Sender).MenuIndex;
        InitStr := DsList.Items[i].connstr;
        DM1.InitDB(InitStr);
        Init;
        DsList.SetFirst(i);
        InitpmnuDBlist;
//        ShowMessage(inttostr(i));        
end;


initialization
  OleInitialize(nil);

finalization
  OleUninitialize;

end.




